﻿using Autofac;
using Autofac.Builder;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cn.Code.Common
{
    /// <summary>
    /// Autofac 扩展注入方法
    /// </summary>
    public static class RegistExtensions
    {
        /// <summary>
        /// 
        /// </summary>
        /// <typeparam name="T">需要注入的接口类型</typeparam>
        /// <param name="builder"></param>
        /// <param name="url">接口服务调用URL</param>
        /// <returns></returns>
        public static IRegistrationBuilder<T, SimpleActivatorData, SingleRegistrationStyle> RegisterService<T>(this ContainerBuilder builder, string url)
        {
            return builder.Register(c => WcfInvokeFactory.GetService<T>(url)).As<T>();
        }
    }
}
